SystemOrganization addCategory: #Metaprogramacion!

Object subclass: #AbstractDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractDetector class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 20:07'!
nonExistingMethodMessage

	^'Clase no contiene este mensaje'.! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:14'!
compiledMethod: message from: class 
	
	[^class methodDict at: message.]
		on: Error
		do: [ Error signal: 'Clase no contiene este mensaje' ].
	! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:14'!
isMethodAbstract: message from: class 
	
	|method|
	
	method := self compiledMethod: message from: class.
	^method isAbstract .
	! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:09'!
subclassesNotImplementedMethods: message from: class 
	
	|method|
	
	(self isMethodAbstract: message from: class)
		ifTrue:[ 
				"2 formas:
				recorrer allSubclasses, indicar las hojas viendo que no tengan subclases, y ver que en sus superclasses exista uno que tenga el metodo implementado, si no, agregarlo a la lista "
				"Recorrer allSubclasses, por cada clase, ver si lo tiene implementado, y si lo tiene, encolar todas sus subclases. Al finalizar, recorrerlo de vuelta y agregar a la lista las concretas que
				no estn en esa cola"
				" Pablo eleg vo' "
			]
		ifFalse:[
				" No es mtodo abstracto, devolve lista vacia "
			]
	! !

Object subclass: #ClassWithAbstractMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassWithAbstractMethod subclass: #ClassImplementingAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstract subclass: #Class1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstract subclass: #Class2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassImplementingAbstract methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 19:58'!
abstractMethod
 	
	^1.! !

ClassWithAbstractMethod subclass: #ClassNotImplementingAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassNotImplementingAbstract subclass: #ClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassNotImplementingAbstract subclass: #ClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassNotImplementingAbstract subclass: #ClassCImplements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassCImplements methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:24'!
abstractMethod 
	 
	^1.! !

!ClassWithAbstractMethod methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 19:58'!
abstractMethod
  
	^ self subclassResponsibility.! !

!ClassWithAbstractMethod methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:18'!
instanceMethod
  
	^ 1.! !

Object subclass: #ClassWithOutAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassWithOutAbstract methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 19:58'!
method

	^1.! !

TestCase subclass: #Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!Tests methodsFor: 'Something' stamp: 'PabloRago 6/19/2013 20:58'!
abstractDetector

	^ AbstractDetector new.
	
"can understand, 
hay que devolver las clases concretas, las hojas
las clases intermedias pueden implementar el mtodo abstracto "! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/19/2013 20:06'!
test00AbstractDetectorShouldRaiseErrorWithNonExistingMethod
	
	|abstractDetector|
	
	abstractDetector := self abstractDetector.
	
	self should: [ 
		abstractDetector isMethodAbstract: #nonExistingMehod from: ClassWithAbstractMethod
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ',AbstractDetector nonExistingMethodMessage)) ].! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/19/2013 21:18'!
test01AbstractDetectorShouldReturnIfMethodClassIsAbstract

	|abstractDetector|

	abstractDetector := self abstractDetector.
	self assert: (abstractDetector isMethodAbstract: #abstractMethod from: ClassWithAbstractMethod).
	
	self deny: (abstractDetector isMethodAbstract: #instanceMethod from: ClassWithAbstractMethod).
	 ! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/19/2013 21:21'!
test02AbstractDetectorShouldReturnEmptyWhenAllConcreteSubclassesUnderstandsAbstractMethod

	|abstractDetector classesThatNotImplementAbstractMethod|

	abstractDetector := self abstractDetector.
	classesThatNotImplementAbstractMethod := abstractDetector subclassesNotImplementedMethods: #abstractMethod from: ClassWithAbstractMethod.
	self assert: (classesThatNotImplementAbstractMethod isEmpty).
	 ! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/19/2013 21:21'!
test03AbstractDetectorShouldReturnTheConcreteSubclassesThatCantUnderstandTheAbstractMethod

	abstractDetector := self abstractDetector.
	 ! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/19/2013 21:20'!
test04AbstractDetectorShouldReturnOnlyConcreteSubclassesThatCantUnderstandTheAbstractMethod
	 ! !
